/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.45 Revision 1.382
1# Copyright 1999-2003 Gentoo Technologies, Inc. 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.45 2003/07/18 20:43:00 wolf31o2 Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.382 2012/02/14 16:08:54 vapier Exp $
4#
5# Author: Martin Schlemmer <azarah@gentoo.org>
6#
7# This eclass is for general purpose functions that most ebuilds
8# have to implement themselves.
9#
10# NB: If you add anything, please comment it!
11 4
12ECLASS=eutils 5# @ECLASS: eutils.eclass
13INHERITED="$INHERITED $ECLASS" 6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
14#
15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass!
14 17
15DEPEND="$DEPEND !bootstrap? ( sys-devel/patch )" 18if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
19___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
20
21inherit multilib portability user
16 22
17DESCRIPTION="Based on the ${ECLASS} eclass" 23DESCRIPTION="Based on the ${ECLASS} eclass"
18 24
19# This function generate linker scripts in /usr/lib for dynamic 25if has "${EAPI:-0}" 0 1 2; then
20# libs in /lib. This is to fix linking problems when you have
21# the .so in /lib, and the .a in /usr/lib. What happens is that
22# in some cases when linking dynamic, the .a in /usr/lib is used
23# instead of the .so in /lib due to gcc/libtool tweaking ld's
24# library search path. This cause many builds to fail.
25# See bug #4411 for more info.
26#
27# To use, simply call:
28#
29# gen_usr_ldscript libfoo.so
30#
31# Note that you should in general use the unversioned name of
32# the library, as ldconfig should usually update it correctly
33# to point to the latest version of the library present.
34#
35# <azarah@gentoo.org> (26 Oct 2002)
36#
37gen_usr_ldscript() {
38 26
39 # Just make sure it exists 27# @FUNCTION: epause
40 dodir /usr/lib 28# @USAGE: [seconds]
41 29# @DESCRIPTION:
42 cat > ${D}/usr/lib/$1 <<"END_LDSCRIPT" 30# Sleep for the specified number of seconds (default of 5 seconds). Useful when
43/* GNU ld script 31# printing a message the user should probably be reading and often used in
44 Because Gentoo have critical dynamic libraries 32# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
45 in /lib, and the static versions in /usr/lib, we 33# don't wait at all. Defined in EAPIs 0 1 and 2.
46 need to have a "fake" dynamic lib in /usr/lib, 34epause() {
47 otherwise we run into linking problems. 35 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
48 See bug #4411 on http://bugs.gentoo.org/ for
49 more info. */
50GROUP ( /lib/libxxx )
51END_LDSCRIPT
52
53 dosed "s:libxxx:$1:" /usr/lib/$1
54
55 return 0
56} 36}
57 37
58# Simple function to draw a line consisting of '=' the same length as $* 38# @FUNCTION: ebeep
59# 39# @USAGE: [number of beeps]
60# <azarah@gentoo.org> (11 Nov 2002) 40# @DESCRIPTION:
61# 41# Issue the specified number of beeps (default of 5 beeps). Useful when
62draw_line() { 42# printing a message the user should probably be reading and often used in
43# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
44# don't beep at all. Defined in EAPIs 0 1 and 2.
45ebeep() {
63 local i=0 46 local n
64 local str_length="" 47 if [[ -z ${EBEEP_IGNORE} ]] ; then
65 48 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
66 # Handle calls that do not have args, or wc not being installed ...
67 if [ -z "$1" -o ! -x "$(which wc 2>/dev/null)" ]
68 then
69 echo "==============================================================="
70 return 0
71 fi
72
73 # Get the length of $*
74 str_length="$(echo -n "$*" | wc -m)"
75
76 while [ "$i" -lt "${str_length}" ]
77 do
78 echo -n "=" 49 echo -ne "\a"
79 50 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
80 i=$((i + 1)) 51 echo -ne "\a"
52 sleep 1
81 done 53 done
54 fi
55}
82 56
83 echo 57else
84 58
59ebeep() {
60 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
61}
62
63epause() {
64 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
65}
66
67fi
68
69# @FUNCTION: eqawarn
70# @USAGE: [message]
71# @DESCRIPTION:
72# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
73# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
74# profile.
75if ! declare -F eqawarn >/dev/null ; then
76 eqawarn() {
77 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
78 :
79 }
80fi
81
82# @FUNCTION: ecvs_clean
83# @USAGE: [list of dirs]
84# @DESCRIPTION:
85# Remove CVS directories recursiveley. Useful when a source tarball contains
86# internal CVS directories. Defaults to $PWD.
87ecvs_clean() {
88 [[ -z $* ]] && set -- .
89 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
90 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
91}
92
93# @FUNCTION: esvn_clean
94# @USAGE: [list of dirs]
95# @DESCRIPTION:
96# Remove .svn directories recursiveley. Useful when a source tarball contains
97# internal Subversion directories. Defaults to $PWD.
98esvn_clean() {
99 [[ -z $* ]] && set -- .
100 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
101}
102
103# @FUNCTION: estack_push
104# @USAGE: <stack> [items to push]
105# @DESCRIPTION:
106# Push any number of items onto the specified stack. Pick a name that
107# is a valid variable (i.e. stick to alphanumerics), and push as many
108# items as you like onto the stack at once.
109#
110# The following code snippet will echo 5, then 4, then 3, then ...
111# @CODE
112# estack_push mystack 1 2 3 4 5
113# while estack_pop mystack i ; do
114# echo "${i}"
115# done
116# @CODE
117estack_push() {
118 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
119 local stack_name="__ESTACK_$1__" ; shift
120 eval ${stack_name}+=\( \"\$@\" \)
121}
122
123# @FUNCTION: estack_pop
124# @USAGE: <stack> [variable]
125# @DESCRIPTION:
126# Pop a single item off the specified stack. If a variable is specified,
127# the popped item is stored there. If no more items are available, return
128# 1, else return 0. See estack_push for more info.
129estack_pop() {
130 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
131
132 # We use the fugly __estack_xxx var names to avoid collision with
133 # passing back the return value. If we used "local i" and the
134 # caller ran `estack_pop ... i`, we'd end up setting the local
135 # copy of "i" rather than the caller's copy. The __estack_xxx
136 # garbage is preferable to using $1/$2 everywhere as that is a
137 # bit harder to read.
138 local __estack_name="__ESTACK_$1__" ; shift
139 local __estack_retvar=$1 ; shift
140 eval local __estack_i=\${#${__estack_name}\[@\]}
141 # Don't warn -- let the caller interpret this as a failure
142 # or as normal behavior (akin to `shift`)
143 [[ $(( --__estack_i )) -eq -1 ]] && return 1
144
145 if [[ -n ${__estack_retvar} ]] ; then
146 eval ${__estack_retvar}=\"\${${__estack_name}\[${__estack_i}\]}\"
147 fi
148 eval unset ${__estack_name}\[${__estack_i}\]
149}
150
151# @FUNCTION: eshopts_push
152# @USAGE: [options to `set` or `shopt`]
153# @DESCRIPTION:
154# Often times code will want to enable a shell option to change code behavior.
155# Since changing shell options can easily break other pieces of code (which
156# assume the default state), eshopts_push is used to (1) push the current shell
157# options onto a stack and (2) pass the specified arguments to set.
158#
159# If the first argument is '-s' or '-u', we assume you want to call `shopt`
160# rather than `set` as there are some options only available via that.
161#
162# A common example is to disable shell globbing so that special meaning/care
163# may be used with variables/arguments to custom functions. That would be:
164# @CODE
165# eshopts_push -s noglob
166# for x in ${foo} ; do
167# if ...some check... ; then
168# eshopts_pop
85 return 0 169# return 0
170# fi
171# done
172# eshopts_pop
173# @CODE
174eshopts_push() {
175 if [[ $1 == -[su] ]] ; then
176 estack_push eshopts "$(shopt -p)"
177 [[ $# -eq 0 ]] && return 0
178 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
179 else
180 estack_push eshopts $-
181 [[ $# -eq 0 ]] && return 0
182 set "$@" || die "${FUNCNAME}: bad options to set: $*"
183 fi
86} 184}
87 185
88# Default directory where patches are located 186# @FUNCTION: eshopts_pop
187# @USAGE:
188# @DESCRIPTION:
189# Restore the shell options to the state saved with the corresponding
190# eshopts_push call. See that function for more details.
191eshopts_pop() {
192 local s
193 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
194 if [[ ${s} == "shopt -"* ]] ; then
195 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
196 else
197 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
198 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
199 fi
200}
201
202# @FUNCTION: eumask_push
203# @USAGE: <new umask>
204# @DESCRIPTION:
205# Set the umask to the new value specified while saving the previous
206# value onto a stack. Useful for temporarily changing the umask.
207eumask_push() {
208 estack_push eumask "$(umask)"
209 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
210}
211
212# @FUNCTION: eumask_pop
213# @USAGE:
214# @DESCRIPTION:
215# Restore the previous umask state.
216eumask_pop() {
217 [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
218 local s
219 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
220 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
221}
222
223# @VARIABLE: EPATCH_SOURCE
224# @DESCRIPTION:
225# Default directory to search for patches.
89EPATCH_SOURCE="${WORKDIR}/patch" 226EPATCH_SOURCE="${WORKDIR}/patch"
90# Default extension for patches 227# @VARIABLE: EPATCH_SUFFIX
228# @DESCRIPTION:
229# Default extension for patches (do not prefix the period yourself).
91EPATCH_SUFFIX="patch.bz2" 230EPATCH_SUFFIX="patch.bz2"
231# @VARIABLE: EPATCH_OPTS
232# @DESCRIPTION:
92# Default options for patch 233# Default options for patch:
93EPATCH_OPTS="" 234# @CODE
235# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
236# --no-backup-if-mismatch - do not leave .orig files behind
237# -E - automatically remove empty files
238# @CODE
239EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
240# @VARIABLE: EPATCH_EXCLUDE
241# @DESCRIPTION:
94# List of patches not to apply. Not this is only file names, 242# List of patches not to apply. Note this is only file names,
95# and not the full path .. 243# and not the full path. Globs accepted.
96EPATCH_EXCLUDE="" 244EPATCH_EXCLUDE=""
245# @VARIABLE: EPATCH_SINGLE_MSG
246# @DESCRIPTION:
97# Change the printed message for a single patch. 247# Change the printed message for a single patch.
98EPATCH_SINGLE_MSG="" 248EPATCH_SINGLE_MSG=""
99# Force applying bulk patches even if not following the style: 249# @VARIABLE: EPATCH_MULTI_MSG
100# 250# @DESCRIPTION:
101# ??_${ARCH}_foo.${EPATCH_SUFFIX} 251# Change the printed message for multiple patches.
102# 252EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
253# @VARIABLE: EPATCH_FORCE
254# @DESCRIPTION:
255# Only require patches to match EPATCH_SUFFIX rather than the extended
256# arch naming style.
103EPATCH_FORCE="no" 257EPATCH_FORCE="no"
104 258
105# This function is for bulk patching, or in theory for just one 259# @FUNCTION: epatch
106# or two patches. 260# @USAGE: [patches] [dirs of patches]
261# @DESCRIPTION:
262# epatch is designed to greatly simplify the application of patches. It can
263# process patch files directly, or directories of patches. The patches may be
264# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
265# the -p option as epatch will automatically attempt -p0 to -p5 until things
266# apply successfully.
107# 267#
108# It should work with .bz2, .gz, .zip and plain text patches. 268# If you do not specify any options, then epatch will default to the directory
109# Currently all patches should be the same format. 269# specified by EPATCH_SOURCE.
110# 270#
111# You do not have to specify '-p' option to patch, as it will 271# When processing directories, epatch will apply all patches that match:
112# try with -p0 to -p5 until it succeed, or fail at -p5. 272# @CODE
113# 273# if ${EPATCH_FORCE} != "yes"
114# Above EPATCH_* variables can be used to control various defaults,
115# bug they should be left as is to ensure an ebuild can rely on
116# them for.
117#
118# Patches are applied in current directory.
119#
120# Bulk Patches should preferibly have the form of:
121#
122# ??_${ARCH}_foo.${EPATCH_SUFFIX} 274# ??_${ARCH}_foo.${EPATCH_SUFFIX}
275# else
276# *.${EPATCH_SUFFIX}
277# @CODE
278# The leading ?? are typically numbers used to force consistent patch ordering.
279# The arch field is used to apply patches only for the host architecture with
280# the special value of "all" means apply for everyone. Note that using values
281# other than "all" is highly discouraged -- you should apply patches all the
282# time and let architecture details be detected at configure/compile time.
123# 283#
124# For example: 284# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
285# for patches to apply.
125# 286#
126# 01_all_misc-fix.patch.bz2 287# Refer to the other EPATCH_xxx variables for more customization of behavior.
127# 02_sparc_another-fix.patch.bz2
128#
129# This ensures that there are a set order, and you can have ARCH
130# specific patches.
131#
132# If you however give an argument to epatch(), it will treat it as a
133# single patch that need to be applied if its a file. If on the other
134# hand its a directory, it will set EPATCH_SOURCE to this.
135#
136# <azarah@gentoo.org> (10 Nov 2002)
137#
138epatch() { 288epatch() {
139 local PIPE_CMD="" 289 _epatch_draw_line() {
140 local STDERR_TARGET="${T}/$$.out" 290 # create a line of same length as input string
141 local PATCH_TARGET="${T}/$$.patch" 291 [[ -z $1 ]] && set "$(printf "%65s" '')"
142 local PATCH_SUFFIX="" 292 echo "${1//?/=}"
293 }
294
295 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
296
297 # Let the rest of the code process one user arg at a time --
298 # each arg may expand into multiple patches, and each arg may
299 # need to start off with the default global EPATCH_xxx values
300 if [[ $# -gt 1 ]] ; then
301 local m
302 for m in "$@" ; do
303 epatch "${m}"
304 done
305 return 0
306 fi
307
143 local SINGLE_PATCH="no" 308 local SINGLE_PATCH="no"
144 local x="" 309 # no args means process ${EPATCH_SOURCE}
310 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
145 311
146 if [ "$#" -gt 1 ] 312 if [[ -f $1 ]] ; then
147 then
148 eerror "Invalid arguments to epatch()"
149 die "Invalid arguments to epatch()"
150 fi
151
152 if [ -n "$1" -a -f "$1" ]
153 then
154 SINGLE_PATCH="yes" 313 SINGLE_PATCH="yes"
155 314 set -- "$1"
156 local EPATCH_SOURCE="$1" 315 # Use the suffix from the single patch (localize it); the code
316 # below will find the suffix for us
157 local EPATCH_SUFFIX="${1##*\.}" 317 local EPATCH_SUFFIX=$1
158 318
159 elif [ -n "$1" -a -d "$1" ] 319 elif [[ -d $1 ]] ; then
160 then 320 # Some people like to make dirs of patches w/out suffixes (vim)
161 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 321 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
162 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 322
323 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
324 # Re-use EPATCH_SOURCE as a search dir
325 epatch "${EPATCH_SOURCE}/$1"
326 return $?
327
328 else
329 # sanity check ... if it isn't a dir or file, wtf man ?
330 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
331 echo
332 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
333 eerror
334 eerror " ${EPATCH_SOURCE}"
335 eerror " ( ${EPATCH_SOURCE##*/} )"
336 echo
337 die "Cannot find \$EPATCH_SOURCE!"
338 fi
339
340 local PIPE_CMD
341 case ${EPATCH_SUFFIX##*\.} in
342 xz) PIPE_CMD="xz -dc" ;;
343 lzma) PIPE_CMD="lzma -dc" ;;
344 bz2) PIPE_CMD="bzip2 -dc" ;;
345 gz|Z|z) PIPE_CMD="gzip -dc" ;;
346 ZIP|zip) PIPE_CMD="unzip -p" ;;
347 *) ;;
348 esac
349
350 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
351
352 local x
353 for x in "$@" ; do
354 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
355 # didn't match anything, ignore continue on
356 [[ ! -f ${x} ]] && continue
357
358 local patchname=${x##*/}
359
360 # Apply single patches, or forced sets of patches, or
361 # patches with ARCH dependant names.
362 # ???_arch_foo.patch
363 # Else, skip this input altogether
364 local a=${patchname#*_} # strip the ???_
365 a=${a%%_*} # strip the _foo.patch
366 if ! [[ ${SINGLE_PATCH} == "yes" || \
367 ${EPATCH_FORCE} == "yes" || \
368 ${a} == all || \
369 ${a} == ${ARCH} ]]
163 then 370 then
164 local EPATCH_SOURCE="$1/*" 371 continue
372 fi
373
374 # Let people filter things dynamically
375 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
376 # let people use globs in the exclude
377 eshopts_push -o noglob
378
379 local ex
380 for ex in ${EPATCH_EXCLUDE} ; do
381 if [[ ${patchname} == ${ex} ]] ; then
382 eshopts_pop
383 continue 2
384 fi
385 done
386
387 eshopts_pop
388 fi
389
390 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
391 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
392 einfo "${EPATCH_SINGLE_MSG}"
393 else
394 einfo "Applying ${patchname} ..."
395 fi
165 else 396 else
166 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 397 einfo " ${patchname} ..."
398 fi
399
400 # most of the time, there will only be one run per unique name,
401 # but if there are more, make sure we get unique log filenames
402 local STDERR_TARGET="${T}/${patchname}.out"
403 if [[ -e ${STDERR_TARGET} ]] ; then
404 STDERR_TARGET="${T}/${patchname}-$$.out"
405 fi
406
407 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
408
409 # Decompress the patch if need be
410 local count=0
411 local PATCH_TARGET
412 if [[ -n ${PIPE_CMD} ]] ; then
413 PATCH_TARGET="${T}/$$.patch"
414 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
415
416 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
417 echo
418 eerror "Could not extract patch!"
419 #die "Could not extract patch!"
420 count=5
421 break
167 fi 422 fi
423 else
424 PATCH_TARGET=${x}
425 fi
426
427 # Check for absolute paths in patches. If sandbox is disabled,
428 # people could (accidently) patch files in the root filesystem.
429 # Or trigger other unpleasantries #237667. So disallow -p0 on
430 # such patches.
431 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
432 if [[ -n ${abs_paths} ]] ; then
433 count=1
434 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
435 fi
436 # Similar reason, but with relative paths.
437 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
438 if [[ -n ${rel_paths} ]] ; then
439 eqawarn "QA Notice: Your patch uses relative paths '../'."
440 eqawarn " In the future this will cause a failure."
441 eqawarn "${rel_paths}"
442 fi
443
444 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
445 while [[ ${count} -lt 5 ]] ; do
446 # Generate some useful debug info ...
447 (
448 _epatch_draw_line "***** ${patchname} *****"
449 echo
450 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
451 echo
452 _epatch_draw_line "***** ${patchname} *****"
453 patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}" 2>&1
454 ret=$?
455 echo
456 echo "patch program exited with status ${ret}"
457 exit ${ret}
458 ) >> "${STDERR_TARGET}"
459
460 if [ $? -eq 0 ] ; then
461 (
462 _epatch_draw_line "***** ${patchname} *****"
463 echo
464 echo "ACTUALLY APPLYING ${patchname} ..."
465 echo
466 _epatch_draw_line "***** ${patchname} *****"
467 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
468 ret=$?
469 echo
470 echo "patch program exited with status ${ret}"
471 exit ${ret}
472 ) >> "${STDERR_TARGET}"
473
474 if [ $? -ne 0 ] ; then
475 echo
476 eerror "A dry-run of patch command succeeded, but actually"
477 eerror "applying the patch failed!"
478 #die "Real world sux compared to the dreamworld!"
479 count=5
480 fi
481 break
482 fi
483
484 : $(( count++ ))
485 done
486
487 # if we had to decompress the patch, delete the temp one
488 if [[ -n ${PIPE_CMD} ]] ; then
489 rm -f "${PATCH_TARGET}"
490 fi
491
492 if [[ ${count} -ge 5 ]] ; then
493 echo
494 eerror "Failed Patch: ${patchname} !"
495 eerror " ( ${PATCH_TARGET} )"
496 eerror
497 eerror "Include in your bugreport the contents of:"
498 eerror
499 eerror " ${STDERR_TARGET}"
500 echo
501 die "Failed Patch: ${patchname}!"
502 fi
503
504 # if everything worked, delete the patch log
505 rm -f "${STDERR_TARGET}"
506 eend 0
507 done
508
509 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
510 : # everything worked
511}
512
513# @FUNCTION: epatch_user
514# @USAGE:
515# @DESCRIPTION:
516# Applies user-provided patches to the source tree. The patches are
517# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
518# of these three directories to exist will be the one to use, ignoring
519# any more general directories which might exist as well.
520#
521# User patches are intended for quick testing of patches without ebuild
522# modifications, as well as for permanent customizations a user might
523# desire. Obviously, there can be no official support for arbitrarily
524# patched ebuilds. So whenever a build log in a bug report mentions that
525# user patches were applied, the user should be asked to reproduce the
526# problem without these.
527#
528# Not all ebuilds do call this function, so placing patches in the
529# stated directory might or might not work, depending on the package and
530# the eclasses it inherits and uses. It is safe to call the function
531# repeatedly, so it is always possible to add a call at the ebuild
532# level. The first call is the time when the patches will be
533# applied.
534#
535# Ideally, this function should be called after gentoo-specific patches
536# have been applied, so that their code can be modified as well, but
537# before calls to e.g. eautoreconf, as the user patches might affect
538# autotool input files as well.
539epatch_user() {
540 [[ $# -ne 0 ]] && die "epatch_user takes no options"
541
542 # Allow multiple calls to this function; ignore all but the first
543 local applied="${T}/epatch_user.applied"
544 [[ -e ${applied} ]] && return 2
545
546 # don't clobber any EPATCH vars that the parent might want
547 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
548 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}; do
549 EPATCH_SOURCE=${base}/${CTARGET}/${check}
550 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
551 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
552 if [[ -d ${EPATCH_SOURCE} ]] ; then
553 EPATCH_SOURCE=${EPATCH_SOURCE} \
554 EPATCH_SUFFIX="patch" \
555 EPATCH_FORCE="yes" \
556 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
557 epatch
558 echo "${EPATCH_SOURCE}" > "${applied}"
559 return 0
560 fi
561 done
562 echo "none" > "${applied}"
563 return 1
564}
565
566# @FUNCTION: emktemp
567# @USAGE: [temp dir]
568# @DESCRIPTION:
569# Cheap replacement for when debianutils (and thus mktemp)
570# does not exist on the users system.
571emktemp() {
572 local exe="touch"
573 [[ $1 == -d ]] && exe="mkdir" && shift
574 local topdir=$1
575
576 if [[ -z ${topdir} ]] ; then
577 [[ -z ${T} ]] \
578 && topdir="/tmp" \
579 || topdir=${T}
580 fi
581
582 if ! type -P mktemp > /dev/null ; then
583 # system lacks `mktemp` so we have to fake it
584 local tmp=/
585 while [[ -e ${tmp} ]] ; do
586 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
587 done
588 ${exe} "${tmp}" || ${exe} -p "${tmp}"
589 echo "${tmp}"
168 else 590 else
169 if [ ! -d ${EPATCH_SOURCE} ] 591 # the args here will give slightly wierd names on BSD,
170 then 592 # but should produce a usable file on all userlands
171 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 593 if [[ ${exe} == "touch" ]] ; then
172 then 594 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
173 EPATCH_SOURCE="$1" 595 else
596 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
597 fi
598 fi
599}
600
601# @FUNCTION: edos2unix
602# @USAGE: <file> [more files ...]
603# @DESCRIPTION:
604# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
605# to remove all of these text utilities from DEPEND variables because this
606# is a script based solution. Just give it a list of files to convert and
607# they will all be changed from the DOS CRLF format to the UNIX LF format.
608edos2unix() {
609 [[ $# -eq 0 ]] && return 0
610 sed -i 's/\r$//' -- "$@" || die
611}
612
613# @FUNCTION: make_desktop_entry
614# @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
615# @DESCRIPTION:
616# Make a .desktop file.
617#
618# @CODE
619# binary: what command does the app run with ?
620# name: the name that will show up in the menu
621# icon: give your little like a pretty little icon ...
622# this can be relative (to /usr/share/pixmaps) or
623# a full path to an icon
624# type: what kind of application is this?
625# for categories:
626# http://standards.freedesktop.org/menu-spec/latest/apa.html
627# if unset, function tries to guess from package's category
628# fields: extra fields to append to the desktop file; a printf string
629# @CODE
630make_desktop_entry() {
631 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
632
633 local exec=${1}
634 local name=${2:-${PN}}
635 local icon=${3:-${PN}}
636 local type=${4}
637 local fields=${5}
638
639 if [[ -z ${type} ]] ; then
640 local catmaj=${CATEGORY%%-*}
641 local catmin=${CATEGORY##*-}
642 case ${catmaj} in
643 app)
644 case ${catmin} in
645 accessibility) type=Accessibility;;
646 admin) type=System;;
647 antivirus) type=System;;
648 arch) type=Archiving;;
649 backup) type=Archiving;;
650 cdr) type=DiscBurning;;
651 dicts) type=Dictionary;;
652 doc) type=Documentation;;
653 editors) type=TextEditor;;
654 emacs) type=TextEditor;;
655 emulation) type=Emulator;;
656 laptop) type=HardwareSettings;;
657 office) type=Office;;
658 pda) type=PDA;;
659 vim) type=TextEditor;;
660 xemacs) type=TextEditor;;
661 esac
662 ;;
663
664 dev)
665 type="Development"
666 ;;
667
668 games)
669 case ${catmin} in
670 action|fps) type=ActionGame;;
671 arcade) type=ArcadeGame;;
672 board) type=BoardGame;;
673 emulation) type=Emulator;;
674 kids) type=KidsGame;;
675 puzzle) type=LogicGame;;
676 roguelike) type=RolePlaying;;
677 rpg) type=RolePlaying;;
678 simulation) type=Simulation;;
679 sports) type=SportsGame;;
680 strategy) type=StrategyGame;;
681 esac
682 type="Game;${type}"
683 ;;
684
685 gnome)
686 type="Gnome;GTK"
687 ;;
688
689 kde)
690 type="KDE;Qt"
691 ;;
692
693 mail)
694 type="Network;Email"
695 ;;
696
697 media)
698 case ${catmin} in
699 gfx)
700 type=Graphics
701 ;;
702 *)
703 case ${catmin} in
704 radio) type=Tuner;;
705 sound) type=Audio;;
706 tv) type=TV;;
707 video) type=Video;;
708 esac
709 type="AudioVideo;${type}"
710 ;;
711 esac
712 ;;
713
714 net)
715 case ${catmin} in
716 dialup) type=Dialup;;
717 ftp) type=FileTransfer;;
718 im) type=InstantMessaging;;
719 irc) type=IRCClient;;
720 mail) type=Email;;
721 news) type=News;;
722 nntp) type=News;;
723 p2p) type=FileTransfer;;
724 voip) type=Telephony;;
725 esac
726 type="Network;${type}"
727 ;;
728
729 sci)
730 case ${catmin} in
731 astro*) type=Astronomy;;
732 bio*) type=Biology;;
733 calc*) type=Calculator;;
734 chem*) type=Chemistry;;
735 elec*) type=Electronics;;
736 geo*) type=Geology;;
737 math*) type=Math;;
738 physics) type=Physics;;
739 visual*) type=DataVisualization;;
740 esac
741 type="Education;Science;${type}"
742 ;;
743
744 sys)
745 type="System"
746 ;;
747
748 www)
749 case ${catmin} in
750 client) type=WebBrowser;;
751 esac
752 type="Network;${type}"
753 ;;
754
755 *)
756 type=
757 ;;
758 esac
759 fi
760 if [ "${SLOT}" == "0" ] ; then
761 local desktop_name="${PN}"
762 else
763 local desktop_name="${PN}-${SLOT}"
764 fi
765 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
766 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
767
768 # Don't append another ";" when a valid category value is provided.
769 type=${type%;}${type:+;}
770
771 eshopts_push -s extglob
772 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
773 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
774 ewarn "allowed in .desktop files if the value is not an absolute path."
775 icon=${icon%.@(xpm|png|svg)}
776 fi
777 eshopts_pop
778
779 cat <<-EOF > "${desktop}"
780 [Desktop Entry]
781 Name=${name}
782 Type=Application
783 Comment=${DESCRIPTION}
784 Exec=${exec}
785 TryExec=${exec%% *}
786 Icon=${icon}
787 Categories=${type}
788 EOF
789
790 if [[ ${fields:-=} != *=* ]] ; then
791 # 5th arg used to be value to Path=
792 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
793 fields="Path=${fields}"
794 fi
795 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
796
797 (
798 # wrap the env here so that the 'insinto' call
799 # doesn't corrupt the env of the caller
800 insinto /usr/share/applications
801 doins "${desktop}"
802 ) || die "installing desktop file failed"
803}
804
805# @FUNCTION: validate_desktop_entries
806# @USAGE: [directories]
807# @MAINTAINER:
808# Carsten Lohrke <carlo@gentoo.org>
809# @DESCRIPTION:
810# Validate desktop entries using desktop-file-utils
811validate_desktop_entries() {
812 if [[ -x /usr/bin/desktop-file-validate ]] ; then
813 einfo "Checking desktop entry validity"
814 local directories=""
815 for d in /usr/share/applications $@ ; do
816 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
817 done
818 if [[ -n ${directories} ]] ; then
819 for FILE in $(find ${directories} -name "*\.desktop" \
820 -not -path '*.hidden*' | sort -u 2>/dev/null)
821 do
822 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
823 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
824 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
825 done
826 fi
827 echo ""
828 else
829 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
830 fi
831}
832
833# @FUNCTION: make_session_desktop
834# @USAGE: <title> <command> [command args...]
835# @DESCRIPTION:
836# Make a GDM/KDM Session file. The title is the file to execute to start the
837# Window Manager. The command is the name of the Window Manager.
838#
839# You can set the name of the file via the ${wm} variable.
840make_session_desktop() {
841 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
842 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
843
844 local title=$1
845 local command=$2
846 local desktop=${T}/${wm:-${PN}}.desktop
847 shift 2
848
849 cat <<-EOF > "${desktop}"
850 [Desktop Entry]
851 Name=${title}
852 Comment=This session logs you into ${title}
853 Exec=${command} $*
854 TryExec=${command}
855 Type=XSession
856 EOF
857
858 (
859 # wrap the env here so that the 'insinto' call
860 # doesn't corrupt the env of the caller
861 insinto /usr/share/xsessions
862 doins "${desktop}"
863 )
864}
865
866# @FUNCTION: domenu
867# @USAGE: <menus>
868# @DESCRIPTION:
869# Install the list of .desktop menu files into the appropriate directory
870# (/usr/share/applications).
871domenu() {
872 (
873 # wrap the env here so that the 'insinto' call
874 # doesn't corrupt the env of the caller
875 local i j ret=0
876 insinto /usr/share/applications
877 for i in "$@" ; do
878 if [[ -f ${i} ]] ; then
879 doins "${i}"
880 ((ret+=$?))
881 elif [[ -d ${i} ]] ; then
882 for j in "${i}"/*.desktop ; do
883 doins "${j}"
884 ((ret+=$?))
885 done
886 else
887 ((++ret))
888 fi
889 done
890 exit ${ret}
891 )
892}
893
894# @FUNCTION: newmenu
895# @USAGE: <menu> <newname>
896# @DESCRIPTION:
897# Like all other new* functions, install the specified menu as newname.
898newmenu() {
899 (
900 # wrap the env here so that the 'insinto' call
901 # doesn't corrupt the env of the caller
902 insinto /usr/share/applications
903 newins "$@"
904 )
905}
906
907# @FUNCTION: doicon
908# @USAGE: <list of icons>
909# @DESCRIPTION:
910# Install the list of icons into the icon directory (/usr/share/pixmaps).
911# This is useful in conjunction with creating desktop/menu files.
912doicon() {
913 (
914 # wrap the env here so that the 'insinto' call
915 # doesn't corrupt the env of the caller
916 local i j ret
917 insinto /usr/share/pixmaps
918 for i in "$@" ; do
919 if [[ -f ${i} ]] ; then
920 doins "${i}"
921 ((ret+=$?))
922 elif [[ -d ${i} ]] ; then
923 for j in "${i}"/*.png ; do
924 doins "${j}"
925 ((ret+=$?))
926 done
927 else
928 ((++ret))
929 fi
930 done
931 exit ${ret}
932 )
933}
934
935# @FUNCTION: newicon
936# @USAGE: <icon> <newname>
937# @DESCRIPTION:
938# Like all other new* functions, install the specified icon as newname.
939newicon() {
940 (
941 # wrap the env here so that the 'insinto' call
942 # doesn't corrupt the env of the caller
943 insinto /usr/share/pixmaps
944 newins "$@"
945 )
946}
947
948# @FUNCTION: cdrom_get_cds
949# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
950# @DESCRIPTION:
951# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
952# the whole 'non-interactive' policy, but damnit I want CD support !
953#
954# With these cdrom functions we handle all the user interaction and
955# standardize everything. All you have to do is call cdrom_get_cds()
956# and when the function returns, you can assume that the cd has been
957# found at CDROM_ROOT.
958#
959# The function will attempt to locate a cd based upon a file that is on
960# the cd. The more files you give this function, the more cds
961# the cdrom functions will handle.
962#
963# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
964# etc... If you want to give the cds better names, then just export
965# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
966# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
967# also use the CDROM_NAME_SET bash array.
968#
969# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
970cdrom_get_cds() {
971 # first we figure out how many cds we're dealing with by
972 # the # of files they gave us
973 local cdcnt=0
974 local f=
975 for f in "$@" ; do
976 ((++cdcnt))
977 export CDROM_CHECK_${cdcnt}="$f"
978 done
979 export CDROM_TOTAL_CDS=${cdcnt}
980 export CDROM_CURRENT_CD=1
981
982 # now we see if the user gave use CD_ROOT ...
983 # if they did, let's just believe them that it's correct
984 if [[ -n ${CD_ROOT}${CD_ROOT_1} ]] ; then
985 local var=
986 cdcnt=0
987 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
988 ((++cdcnt))
989 var="CD_ROOT_${cdcnt}"
990 [[ -z ${!var} ]] && var="CD_ROOT"
991 if [[ -z ${!var} ]] ; then
992 eerror "You must either use just the CD_ROOT"
993 eerror "or specify ALL the CD_ROOT_X variables."
994 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables."
995 die "could not locate CD_ROOT_${cdcnt}"
174 fi 996 fi
997 done
998 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
999 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1000 export CDROM_SET=-1
1001 for f in ${CDROM_CHECK_1//:/ } ; do
1002 ((++CDROM_SET))
1003 [[ -e ${CDROM_ROOT}/${f} ]] && break
1004 done
1005 export CDROM_MATCH=${f}
1006 return
1007 fi
175 1008
1009 # User didn't help us out so lets make sure they know they can
1010 # simplify the whole process ...
1011 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1012 einfo "This ebuild will need the ${CDROM_NAME:-cdrom for ${PN}}"
176 echo 1013 echo
177 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 1014 einfo "If you do not have the CD, but have the data files"
178 eerror 1015 einfo "mounted somewhere on your filesystem, just export"
179 eerror " ${EPATCH_SOURCE}" 1016 einfo "the variable CD_ROOT so that it points to the"
1017 einfo "directory containing the files."
180 echo 1018 echo
181 die "Cannot find \$EPATCH_SOURCE!" 1019 einfo "For example:"
182 fi 1020 einfo "export CD_ROOT=/mnt/cdrom"
183 1021 echo
184 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}" 1022 else
1023 if [[ -n ${CDROM_NAME_SET} ]] ; then
1024 # Translate the CDROM_NAME_SET array into CDROM_NAME_#
1025 cdcnt=0
1026 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1027 ((++cdcnt))
1028 export CDROM_NAME_${cdcnt}="${CDROM_NAME_SET[$((${cdcnt}-1))]}"
1029 done
185 fi 1030 fi
186 1031
187 case ${EPATCH_SUFFIX##*\.} in 1032 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
188 bz2) 1033 cdcnt=0
189 PIPE_CMD="bzip2 -dc" 1034 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
190 PATCH_SUFFIX="bz2" 1035 ((++cdcnt))
191 ;; 1036 var="CDROM_NAME_${cdcnt}"
192 gz|Z|z) 1037 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}"
193 PIPE_CMD="gzip -dc" 1038 done
194 PATCH_SUFFIX="gz" 1039 echo
195 ;; 1040 einfo "If you do not have the CDs, but have the data files"
196 ZIP|zip) 1041 einfo "mounted somewhere on your filesystem, just export"
197 PIPE_CMD="unzip -p" 1042 einfo "the following variables so they point to the right place:"
198 PATCH_SUFFIX="zip" 1043 einfon ""
199 ;; 1044 cdcnt=0
200 *) 1045 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
201 PIPE_CMD="cat" 1046 ((++cdcnt))
202 PATCH_SUFFIX="patch" 1047 echo -n " CD_ROOT_${cdcnt}"
203 ;; 1048 done
204 esac 1049 echo
1050 einfo "Or, if you have all the files in the same place, or"
1051 einfo "you only have one cdrom, you can export CD_ROOT"
1052 einfo "and that place will be used as the same data source"
1053 einfo "for all the CDs."
1054 echo
1055 einfo "For example:"
1056 einfo "export CD_ROOT_1=/mnt/cdrom"
1057 echo
1058 fi
205 1059
206 if [ "${SINGLE_PATCH}" = "no" ] 1060 export CDROM_SET=""
207 then 1061 export CDROM_CURRENT_CD=0
208 einfo "Applying various patches (bugfixes/updates)..." 1062 cdrom_load_next_cd
1063}
1064
1065# @FUNCTION: cdrom_load_next_cd
1066# @DESCRIPTION:
1067# Some packages are so big they come on multiple CDs. When you're done reading
1068# files off a CD and want access to the next one, just call this function.
1069# Again, all the messy details of user interaction are taken care of for you.
1070# Once this returns, just read the variable CDROM_ROOT for the location of the
1071# mounted CD. Note that you can only go forward in the CD list, so make sure
1072# you only call this function when you're done using the current CD.
1073cdrom_load_next_cd() {
1074 local var
1075 ((++CDROM_CURRENT_CD))
1076
1077 unset CDROM_ROOT
1078 var=CD_ROOT_${CDROM_CURRENT_CD}
1079 [[ -z ${!var} ]] && var="CD_ROOT"
1080 if [[ -z ${!var} ]] ; then
1081 var="CDROM_CHECK_${CDROM_CURRENT_CD}"
1082 _cdrom_locate_file_on_cd ${!var}
1083 else
1084 export CDROM_ROOT=${!var}
1085 fi
1086
1087 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1088}
1089
1090# this is used internally by the cdrom_get_cds() and cdrom_load_next_cd()
1091# functions. this should *never* be called from an ebuild.
1092# all it does is try to locate a give file on a cd ... if the cd isn't
1093# found, then a message asking for the user to insert the cdrom will be
1094# displayed and we'll hang out here until:
1095# (1) the file is found on a mounted cdrom
1096# (2) the user hits CTRL+C
1097_cdrom_locate_file_on_cd() {
1098 local mline=""
1099 local showedmsg=0 showjolietmsg=0
1100
1101 while [[ -z ${CDROM_ROOT} ]] ; do
1102 local i=0
1103 local -a cdset=(${*//:/ })
1104 if [[ -n ${CDROM_SET} ]] ; then
1105 cdset=(${cdset[${CDROM_SET}]})
209 fi 1106 fi
210 for x in ${EPATCH_SOURCE}
211 do
212 # New ARCH dependant patch naming scheme...
213 #
214 # ???_arch_foo.patch
215 #
216 if [ -f ${x} ] && \
217 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "`eval echo \$\{x/_${ARCH}_\}`" != "${x}" ] || \
218 [ "${EPATCH_FORCE}" = "yes" ])
219 then
220 local count=0
221 local popts="${EPATCH_OPTS}"
222 1107
223 if [ -n "${EPATCH_EXCLUDE}" ] 1108 while [[ -n ${cdset[${i}]} ]] ; do
224 then 1109 local dir=$(dirname ${cdset[${i}]})
225 if [ "`eval echo \$\{EPATCH_EXCLUDE/${x##*/}\}`" != "${EPATCH_EXCLUDE}" ] 1110 local file=$(basename ${cdset[${i}]})
226 then 1111
1112 local point= node= fs= foo=
1113 while read point node fs foo ; do
1114 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1115 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
227 continue 1116 && continue
1117 point=${point//\040/ }
1118 [[ ! -d ${point}/${dir} ]] && continue
1119 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1120 export CDROM_ROOT=${point}
1121 export CDROM_SET=${i}
1122 export CDROM_MATCH=${cdset[${i}]}
1123 return
1124 done <<< "$(get_mounts)"
1125
1126 ((++i))
1127 done
1128
1129 echo
1130 if [[ ${showedmsg} -eq 0 ]] ; then
1131 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1132 if [[ -z ${CDROM_NAME} ]] ; then
1133 einfo "Please insert+mount the cdrom for ${PN} now !"
1134 else
1135 einfo "Please insert+mount the ${CDROM_NAME} cdrom now !"
1136 fi
1137 else
1138 if [[ -z ${CDROM_NAME_1} ]] ; then
1139 einfo "Please insert+mount cd #${CDROM_CURRENT_CD} for ${PN} now !"
1140 else
1141 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1142 einfo "Please insert+mount the ${!var} cdrom now !"
228 fi 1143 fi
229 fi 1144 fi
1145 showedmsg=1
1146 fi
1147 einfo "Press return to scan for the cd again"
1148 einfo "or hit CTRL+C to abort the emerge."
1149 echo
1150 if [[ ${showjolietmsg} -eq 0 ]] ; then
1151 showjolietmsg=1
1152 else
1153 ewarn "If you are having trouble with the detection"
1154 ewarn "of your CD, it is possible that you do not have"
1155 ewarn "Joliet support enabled in your kernel. Please"
1156 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1157 ebeep 5
1158 fi
1159 read || die "something is screwed with your system"
1160 done
1161}
230 1162
231 if [ "${SINGLE_PATCH}" = "yes" ] 1163# @FUNCTION: strip-linguas
232 then 1164# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
233 if [ -n "${EPATCH_SINGLE_MSG}" ] 1165# @DESCRIPTION:
234 then 1166# Make sure that LINGUAS only contains languages that
235 einfo "${EPATCH_SINGLE_MSG}" 1167# a package can support. The first form allows you to
1168# specify a list of LINGUAS. The -i builds a list of po
1169# files found in all the directories and uses the
1170# intersection of the lists. The -u builds a list of po
1171# files found in all the directories and uses the union
1172# of the lists.
1173strip-linguas() {
1174 local ls newls nols
1175 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1176 local op=$1; shift
1177 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1178 local d f
1179 for d in "$@" ; do
1180 if [[ ${op} == "-u" ]] ; then
1181 newls=${ls}
1182 else
1183 newls=""
1184 fi
1185 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1186 if [[ ${op} == "-i" ]] ; then
1187 has ${f} ${ls} && newls="${newls} ${f}"
236 else 1188 else
237 einfo "Applying ${x##*/}..." 1189 has ${f} ${ls} || newls="${newls} ${f}"
238 fi 1190 fi
239 else
240 einfo " ${x##*/}..."
241 fi
242
243 echo "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
244 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
245
246 # Allow for prefix to differ ... im lazy, so shoot me :/
247 while [ "${count}" -lt 5 ]
248 do
249 # Generate some useful debug info ...
250 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
251 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
252
253 if [ "${PATCH_SUFFIX}" != "patch" ]
254 then
255 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
256 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
257 else
258 PATCH_TARGET="${x}"
259 fi
260
261 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
262 echo "patch ${popts} -p${count} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
263
264 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
265 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
266
267 if [ "${PATCH_SUFFIX}" != "patch" ]
268 then
269 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1
270 then
271 echo
272 eerror "Could not extract patch!"
273 #die "Could not extract patch!"
274 count=5
275 break
276 fi
277 fi
278
279 if (cat ${PATCH_TARGET} | patch ${popts} --dry-run -f -p${count}) >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1
280 then
281 draw_line "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
282 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
283 echo "ACTUALLY APPLYING ${x##*/}..." >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
284 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
285 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
286
287 cat ${PATCH_TARGET} | patch ${popts} -p${count} >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real 2>&1
288
289 if [ "$?" -ne 0 ]
290 then
291 cat ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
292 echo
293 eerror "A dry-run of patch command succeeded, but actually"
294 eerror "applying the patch failed!"
295 #die "Real world sux compared to the dreamworld!"
296 count=5
297 fi
298
299 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
300
301 break
302 fi
303
304 count=$((count + 1))
305 done 1191 done
306 1192 ls=${newls}
307 if [ "${PATCH_SUFFIX}" != "patch" ] 1193 done
308 then 1194 else
309 rm -f ${PATCH_TARGET} 1195 ls="$@"
310 fi 1196 fi
311 1197
312 if [ "${count}" -eq 5 ] 1198 nols=""
313 then 1199 newls=""
314 echo 1200 for f in ${LINGUAS} ; do
315 eerror "Failed Patch: ${x##*/}!" 1201 if has ${f} ${ls} ; then
316 eerror 1202 newls="${newls} ${f}"
317 eerror "Include in your bugreport the contents of:" 1203 else
318 eerror 1204 nols="${nols} ${f}"
319 eerror " ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}"
320 echo
321 die "Failed Patch: ${x##*/}!"
322 fi
323
324 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
325
326 eend 0
327 fi 1205 fi
328 done 1206 done
329 if [ "${SINGLE_PATCH}" = "no" ] 1207 [[ -n ${nols} ]] \
330 then 1208 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
331 einfo "Done with patching" 1209 export LINGUAS=${newls:1}
332 fi
333} 1210}
334 1211
335# This function return true if we are using the NPTL pthreads 1212# @FUNCTION: preserve_old_lib
336# implementation. 1213# @USAGE: <libs to preserve> [more libs]
337# 1214# @DESCRIPTION:
338# <azarah@gentoo.org> (06 March 2003) 1215# These functions are useful when a lib in your package changes ABI SONAME.
339# 1216# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
340 1217# would break packages that link against it. Most people get around this
341have_NPTL() { 1218# by using the portage SLOT mechanism, but that is not always a relevant
342 1219# solution, so instead you can call this from pkg_preinst. See also the
343 cat > ${T}/test-nptl.c <<-"END" 1220# preserve_old_lib_notify function.
344 #define _XOPEN_SOURCE 1221preserve_old_lib() {
345 #include <unistd.h> 1222 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
346 #include <stdio.h> 1223 eerror "preserve_old_lib() must be called from pkg_preinst() only"
347 1224 die "Invalid preserve_old_lib() usage"
348 int main()
349 {
350 char buf[255];
351 char *str = buf;
352
353 confstr(_CS_GNU_LIBPTHREAD_VERSION, str, 255);
354 if (NULL != str) {
355 printf("%s\n", str);
356 if (NULL != strstr(str, "NPTL"))
357 return 0;
358 }
359
360 return 1;
361 }
362 END
363
364 einfon "Checking for _CS_GNU_LIBPTHREAD_VERSION support in glibc ... "
365 if gcc -o ${T}/nptl ${T}/test-nptl.c &> /dev/null
366 then
367 echo "yes"
368 einfon "Checking what PTHREADS implementation we have ... "
369 if ${T}/nptl
370 then
371 return 0
372 else
373 return 1
374 fi 1225 fi
375 else 1226 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
376 echo "no"
377 fi
378 1227
379 return 1 1228 # let portage worry about it
380} 1229 has preserve-libs ${FEATURES} && return 0
381 1230
382# This function check how many cpu's are present, and then set 1231 local lib dir
383# -j in MAKEOPTS accordingly. 1232 for lib in "$@" ; do
384# 1233 [[ -e ${ROOT}/${lib} ]] || continue
385# Thanks to nall <nall@gentoo.org> for this. 1234 dir=${lib%/*}
386# 1235 dodir ${dir} || die "dodir ${dir} failed"
387get_number_of_jobs() { 1236 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
388 local jobs=0 1237 touch "${D}"/${lib}
1238 done
1239}
389 1240
390 if [ ! -r /proc/cpuinfo ] 1241# @FUNCTION: preserve_old_lib_notify
391 then 1242# @USAGE: <libs to notify> [more libs]
392 return 1 1243# @DESCRIPTION:
393 fi 1244# Spit helpful messages about the libraries preserved by preserve_old_lib.
394 1245preserve_old_lib_notify() {
395 # This bit is from H?kan Wessberg <nacka-gentoo@refug.org>, bug #13565. 1246 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
396 if [ "`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | wc -l`" -gt 0 ] 1247 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
397 then 1248 die "Invalid preserve_old_lib_notify() usage"
398 ADMINOPTS="`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | cut -d= -f2 | sed 's/\"//g'`"
399 ADMINPARAM="`echo ${ADMINOPTS} | gawk '{match($0, /-j *[0-9]*/, opt); print opt[0]}'`"
400 ADMINPARAM="${ADMINPARAM/-j}"
401 fi
402
403 export MAKEOPTS="`echo ${MAKEOPTS} | sed -e 's:-j *[0-9]*::g'`"
404
405 if [ "${ARCH}" = "amd64" -o "${ARCH}" = "x86" -o "${ARCH}" = "hppa" -o \
406 "${ARCH}" = "arm" -o "${ARCH}" = "mips" ]
407 then
408 # these archs will always have "[Pp]rocessor"
409 jobs="$((`grep -c ^[Pp]rocessor /proc/cpuinfo` * 2))"
410
411 elif [ "${ARCH}" = "sparc" -o "${ARCH}" = "sparc64" ]
412 then
413 # sparc always has "ncpus active"
414 jobs="$((`grep "^ncpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
415
416 elif [ "${ARCH}" = "alpha" ]
417 then
418 # alpha has "cpus active", but only when compiled with SMP
419 if [ "`grep -c "^cpus active" /proc/cpuinfo`" -eq 1 ]
420 then
421 jobs="$((`grep "^cpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
422 else
423 jobs=2
424 fi 1249 fi
425 1250
426 elif [ "${ARCH}" = "ppc" ] 1251 # let portage worry about it
427 then 1252 has preserve-libs ${FEATURES} && return 0
428 # ppc has "processor", but only when compiled with SMP 1253
429 if [ "`grep -c "^processor" /proc/cpuinfo`" -eq 1 ] 1254 local lib notice=0
430 then 1255 for lib in "$@" ; do
431 jobs="$((`grep -c ^processor /proc/cpuinfo` * 2))" 1256 [[ -e ${ROOT}/${lib} ]] || continue
432 else 1257 if [[ ${notice} -eq 0 ]] ; then
433 jobs=2 1258 notice=1
434 fi 1259 ewarn "Old versions of installed libraries were detected on your system."
435 else 1260 ewarn "In order to avoid breaking packages that depend on these old libs,"
436 jobs="$((`grep -c ^cpu /proc/cpuinfo` * 2))" 1261 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
437 die "Unknown ARCH -- ${ARCH}!" 1262 ewarn "in order to remove these old dependencies. If you do not have this"
1263 ewarn "helper program, simply emerge the 'gentoolkit' package."
1264 ewarn
438 fi 1265 fi
439 1266 # temp hack for #348634 #357225
440 # Make sure the number is valid ... 1267 [[ ${PN} == "mpfr" ]] && lib=${lib##*/}
441 if [ "${jobs}" -lt 1 ] 1268 ewarn " # revdep-rebuild --library '${lib}'"
442 then 1269 done
443 jobs=1 1270 if [[ ${notice} -eq 1 ]] ; then
444 fi 1271 ewarn
445 1272 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
446 if [ -n "${ADMINPARAM}" ] 1273 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
447 then 1274 for lib in "$@" ; do
448 if [ "${jobs}" -gt "${ADMINPARAM}" ] 1275 ewarn " # rm '${lib}'"
449 then 1276 done
450 einfo "Setting make jobs to \"-j${ADMINPARAM}\" to ensure successful merge..."
451 export MAKEOPTS="${MAKEOPTS} -j${ADMINPARAM}"
452 else
453 einfo "Setting make jobs to \"-j${jobs}\" to ensure successful merge..."
454 export MAKEOPTS="${MAKEOPTS} -j${jobs}"
455 fi 1277 fi
456 fi
457} 1278}
458 1279
459# Simplify/standardize adding users to the system 1280# @FUNCTION: built_with_use
460# vapier@gentoo.org 1281# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1282# @DESCRIPTION:
461# 1283#
462# enewuser(username, uid, shell, homedir, groups, extra options) 1284# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
463# 1285#
464# Default values if you do not specify any: 1286# A temporary hack until portage properly supports DEPENDing on USE
465# username: REQUIRED ! 1287# flags being enabled in packages. This will check to see if the specified
466# uid: next available (see useradd(8)) 1288# DEPEND atom was built with the specified list of USE flags. The
467# note: pass -1 to get default behavior 1289# --missing option controls the behavior if called on a package that does
468# shell: /bin/false 1290# not actually support the defined USE flags (aka listed in IUSE).
469# homedir: /dev/null 1291# The default is to abort (call die). The -a and -o flags control
470# groups: none 1292# the requirements of the USE flags. They correspond to "and" and "or"
471# extra: comment of 'added by portage for ${PN}' 1293# logic. So the -a flag means all listed USE flags must be enabled
472enewuser() { 1294# while the -o flag means at least one of the listed IUSE flags must be
473 # get the username 1295# enabled. The --hidden option is really for internal use only as it
474 local euser="$1"; shift 1296# means the USE flag we're checking is hidden expanded, so it won't be found
475 if [ -z "${euser}" ] ; then 1297# in IUSE like normal USE flags.
476 eerror "No username specified !" 1298#
477 die "Cannot call enewuser without a username" 1299# Remember that this function isn't terribly intelligent so order of optional
478 fi 1300# flags matter.
479 1301built_with_use() {
480 # setup a file for testing usernames/groups 1302 local hidden="no"
481 local tmpfile="`mktemp -p ${T}`" 1303 if [[ $1 == "--hidden" ]] ; then
482 touch ${tmpfile} 1304 hidden="yes"
483 chown ${euser} ${tmpfile} >& /dev/null 1305 shift
484 local realuser="`ls -l ${tmpfile} | awk '{print $3}'`"
485
486 # see if user already exists
487 if [ "${euser}" == "${realuser}" ] ; then
488 return 0
489 fi
490 einfo "Adding user '${euser}' to your system ..."
491
492 # options to pass to useradd
493 local opts=""
494
495 # handle uid
496 local euid="$1"; shift
497 if [ ! -z "${euid}" ] && [ "${euid}" != "-1" ] ; then
498 if [ ${euid} -gt 0 ] ; then
499 opts="${opts} -u ${euid}"
500 else
501 eerror "Userid given but is not greater than 0 !"
502 die "${euid} is not a valid UID"
503 fi 1306 fi
504 else
505 euid="next available"
506 fi
507 einfo " - Userid: ${euid}"
508 1307
509 # handle shell 1308 local missing_action="die"
510 local eshell="$1"; shift 1309 if [[ $1 == "--missing" ]] ; then
511 if [ ! -z "${eshell}" ] ; then 1310 missing_action=$2
512 if [ ! -e ${eshell} ] ; then 1311 shift ; shift
513 eerror "A shell was specified but it does not exist !" 1312 case ${missing_action} in
514 die "${eshell} does not exist" 1313 true|false|die) ;;
1314 *) die "unknown action '${missing_action}'";;
1315 esac
515 fi 1316 fi
516 else
517 eshell=/bin/false
518 fi
519 einfo " - Shell: ${eshell}"
520 opts="${opts} -s ${eshell}"
521 1317
522 # handle homedir 1318 local opt=$1
523 local ehome="$1"; shift 1319 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
524 if [ -z "${ehome}" ] ; then
525 ehome=/dev/null
526 fi
527 einfo " - Home: ${ehome}"
528 opts="${opts} -d ${ehome}"
529 1320
530 # handle groups 1321 local PKG=$(best_version $1)
531 local egroups="$1"; shift 1322 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
532 if [ ! -z "${egroups}" ] ; then 1323 shift
533 local realgroup 1324
534 local oldifs="${IFS}" 1325 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
535 export IFS="," 1326 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
536 for g in ${egroups} ; do 1327
537 chgrp ${g} ${tmpfile} >& /dev/null 1328 # if the IUSE file doesn't exist, the read will error out, we need to handle
538 realgroup="`ls -l ${tmpfile} | awk '{print $4}'`" 1329 # this gracefully
539 if [ "${g}" != "${realgroup}" ] ; then 1330 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
540 eerror "You must add ${g} to the system first" 1331 case ${missing_action} in
541 die "${g} is not a valid GID" 1332 true) return 0;;
1333 false) return 1;;
1334 die) die "Unable to determine what USE flags $PKG was built with";;
1335 esac
1336 fi
1337
1338 if [[ ${hidden} == "no" ]] ; then
1339 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1340 # Don't check USE_EXPAND #147237
1341 local expand
1342 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1343 if [[ $1 == ${expand}_* ]] ; then
1344 expand=""
1345 break
542 fi 1346 fi
543 done 1347 done
544 export IFS="${oldifs}" 1348 if [[ -n ${expand} ]] ; then
545 opts="${opts} -g ${egroups}" 1349 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1350 case ${missing_action} in
1351 true) return 0;;
1352 false) return 1;;
1353 die) die "$PKG does not actually support the $1 USE flag!";;
1354 esac
1355 fi
1356 fi
1357 fi
1358
1359 local USE_BUILT=$(<${USEFILE})
1360 while [[ $# -gt 0 ]] ; do
1361 if [[ ${opt} = "-o" ]] ; then
1362 has $1 ${USE_BUILT} && return 0
1363 else
1364 has $1 ${USE_BUILT} || return 1
1365 fi
1366 shift
1367 done
1368 [[ ${opt} = "-a" ]]
1369}
1370
1371# @FUNCTION: epunt_cxx
1372# @USAGE: [dir to scan]
1373# @DESCRIPTION:
1374# Many configure scripts wrongly bail when a C++ compiler could not be
1375# detected. If dir is not specified, then it defaults to ${S}.
1376#
1377# http://bugs.gentoo.org/73450
1378epunt_cxx() {
1379 local dir=$1
1380 [[ -z ${dir} ]] && dir=${S}
1381 ebegin "Removing useless C++ checks"
1382 local f
1383 find "${dir}" -name configure | while read f ; do
1384 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1385 done
1386 eend 0
1387}
1388
1389# @FUNCTION: make_wrapper
1390# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1391# @DESCRIPTION:
1392# Create a shell wrapper script named wrapper in installpath
1393# (defaults to the bindir) to execute target (default of wrapper) by
1394# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1395# libpaths followed by optionally changing directory to chdir.
1396make_wrapper() {
1397 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1398 local tmpwrapper=$(emktemp)
1399 # We don't want to quote ${bin} so that people can pass complex
1400 # things as $bin ... "./someprog --args"
1401 cat << EOF > "${tmpwrapper}"
1402#!/bin/sh
1403cd "${chdir:-.}"
1404if [ -n "${libdir}" ] ; then
1405 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1406 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
546 else 1407 else
547 egroups="(none)" 1408 export LD_LIBRARY_PATH="${libdir}"
1409 fi
548 fi 1410fi
549 einfo " - Groups: ${egroups}" 1411exec ${bin} "\$@"
550 1412EOF
551 # handle extra and add the user 1413 chmod go+rx "${tmpwrapper}"
552 local eextra="$@" 1414 if [[ -n ${path} ]] ; then
553 local oldsandbox=${SANDBOX_ON} 1415 (
554 export SANDBOX_ON="0" 1416 exeinto "${path}"
555 if [ -z "${eextra}" ] ; then 1417 newexe "${tmpwrapper}" "${wrapper}"
556 useradd ${opts} ${euser} \ 1418 ) || die
557 -c "added by portage for ${PN}" \
558 || die "enewuser failed"
559 else 1419 else
560 einfo " - Extra: ${eextra}" 1420 newbin "${tmpwrapper}" "${wrapper}" || die
561 useradd ${opts} ${euser} ${eextra} \
562 || die "enewuser failed"
563 fi
564 export SANDBOX_ON="${oldsandbox}"
565
566 if [ ! -e ${ehome} ] && [ ! -e ${D}/${ehome} ] ; then
567 einfo " - Creating ${ehome} in ${D}"
568 dodir ${ehome}
569 fowners ${euser} ${ehome}
570 fperms 755 ${ehome}
571 fi
572}
573
574# Simplify/standardize adding groups to the system
575# vapier@gentoo.org
576#
577# enewgroup(group, gid)
578#
579# Default values if you do not specify any:
580# groupname: REQUIRED !
581# gid: next available (see groupadd(8))
582# extra: none
583enewgroup() {
584 # get the group
585 local egroup="$1"; shift
586 if [ -z "${egroup}" ] ; then
587 eerror "No group specified !"
588 die "Cannot call enewgroup without a group"
589 fi
590
591 # setup a file for testing groupname
592 local tmpfile="`mktemp -p ${T}`"
593 touch ${tmpfile}
594 chgrp ${egroup} ${tmpfile} >& /dev/null
595 local realgroup="`ls -l ${tmpfile} | awk '{print $4}'`"
596
597 # see if group already exists
598 if [ "${egroup}" == "${realgroup}" ] ; then
599 return 0
600 fi
601 einfo "Adding group '${egroup}' to your system ..."
602
603 # options to pass to useradd
604 local opts=""
605
606 # handle gid
607 local egid="$1"; shift
608 if [ ! -z "${egid}" ] ; then
609 if [ ${egid} -gt 0 ] ; then
610 opts="${opts} -g ${egid}"
611 else
612 eerror "Groupid given but is not greater than 0 !"
613 die "${egid} is not a valid GID"
614 fi 1421 fi
615 else
616 egid="next available"
617 fi
618 einfo " - Groupid: ${egid}"
619
620 # handle extra
621 local eextra="$@"
622 opts="${opts} ${eextra}"
623
624 # add the group
625 local oldsandbox=${SANDBOX_ON}
626 export SANDBOX_ON="0"
627 groupadd ${opts} ${egroup} || die "enewgroup failed"
628 export SANDBOX_ON="${oldsandbox}"
629} 1422}
630 1423
631# Simple script to replace 'dos2unix' binaries 1424# @FUNCTION: path_exists
632# vapier@gentoo.org 1425# @USAGE: [-a|-o] <paths>
633# 1426# @DESCRIPTION:
634# edos2unix(file, <more files>...) 1427# Check if the specified paths exist. Works for all types of paths
635edos2unix() { 1428# (files/dirs/etc...). The -a and -o flags control the requirements
1429# of the paths. They correspond to "and" and "or" logic. So the -a
1430# flag means all the paths must exist while the -o flag means at least
1431# one of the paths must exist. The default behavior is "and". If no
1432# paths are specified, then the return value is "false".
1433path_exists() {
1434 local opt=$1
1435 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1436
1437 # no paths -> return false
1438 # same behavior as: [[ -e "" ]]
1439 [[ $# -eq 0 ]] && return 1
1440
1441 local p r=0
636 for f in $@ ; do 1442 for p in "$@" ; do
637 cp ${f} ${T}/edos2unix 1443 [[ -e ${p} ]]
638 sed 's/\r$//' ${T}/edos2unix > ${f} 1444 : $(( r += $? ))
639 done 1445 done
640}
641 1446
642# Make a desktop file ! 1447 case ${opt} in
643# Great for making those icons in kde/gnome startmenu ! 1448 -a) return $(( r != 0 )) ;;
644# Amaze your friends ! Get the women ! Join today ! 1449 -o) return $(( r == $# )) ;;
645# gnome2 /usr/share/applications
646# gnome1 /usr/share/gnome/apps/
647# KDE ${KDEDIR}/share/applnk /usr/share/applnk
648#
649# make_desktop_entry(<binary>, [name], [icon], [type], [path])
650#
651# binary: what binary does the app run with ?
652# name: the name that will show up in the menu
653# icon: give your little like a pretty little icon ...
654# this can be relative (to /usr/share/pixmaps) or
655# a full path to an icon
656# type: what kind of application is this ? for categories:
657# http://www.freedesktop.org/standards/menu/draft/menu-spec/menu-spec.html
658# path: if your app needs to startup in a specific dir
659make_desktop_entry() {
660 [ -z "$1" ] && eerror "You must specify the executable" && return 1
661
662 local exec=${1}
663 local name=${2:-${PN}}
664 local icon=${3:-${PN}.png}
665 local type=${4}
666 local path=${5:-${GAMES_PREFIX}}
667 if [ -z "${type}" ] ; then
668 case ${CATEGORY} in
669 app-emulation) type=Emulator ;;
670 app-games) type=Game ;;
671 *) type="" ;;
672 esac 1450 esac
673 fi
674 local desktop=${T}/${exec}.desktop
675
676echo "[Desktop Entry]
677Encoding=UTF-8
678Version=0.9.2
679Name=${name}
680Type=Application
681Comment=${DESCRIPTION}
682Exec=${exec}
683Path=${path}
684Icon=${icon}
685Categories=Application;${type};" > ${desktop}
686
687 if [ -d /usr/share/applications ] ; then
688 insinto /usr/share/applications
689 doins ${desktop}
690 fi
691
692 #if [ -d /usr/share/gnome/apps ] ; then
693 # insinto /usr/share/gnome/apps/Games
694 # doins ${desktop}
695 #fi
696
697 #if [ ! -z "`ls /usr/kde/* 2>/dev/null`" ] ; then
698 # for ver in /usr/kde/* ; do
699 # insinto ${ver}/share/applnk/Games
700 # doins ${desktop}
701 # done
702 #fi
703
704 if [ -d /usr/share/applnk ] ; then
705 insinto /usr/share/applnk/${type}
706 doins ${desktop}
707 fi
708
709 return 0
710} 1451}
711 1452
712# new convenience patch wrapper function to eventually replace epatch(), 1453# @FUNCTION: in_iuse
713# $PATCHES, $PATCHES1, src_unpack:patch, src_unpack:autopatch and 1454# @USAGE: <flag>
714# /usr/bin/patch 1455# @DESCRIPTION:
715# Features: 1456# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
716# - bulk patch handling similar to epatch()'s 1457# as necessary.
717# - automatic patch level detection like epatch()'s 1458#
718# - automatic patch uncompression like epatch()'s 1459# Note that this function should not be used in the global scope.
719# - doesn't have the --dry-run overhead of epatch() - inspects patchfiles 1460in_iuse() {
720# manually instead
721# - once I decide it's production-ready, it'll be called from base_src_unpack
722# to handle $PATCHES to avoid defining src_unpack just to use xpatch
723
724# accepts zero or more parameters specifying patchfiles and/or patchdirs
725
726# known issues:
727# - only supports unified style patches (does anyone _really_ use anything
728# else?)
729# - because it doesn't use --dry-run there is a risk of it failing
730# to find the files to patch, ie detect the patchlevel, properly. It doesn't use
731# any of the backup heuristics that patch employs to discover a filename.
732# however, this isn't dangerous because if it works for the developer who's
733# writing the ebuild, it'll always work for the users, and if it doesn't,
734# then we'll fix it :-)
735# - no support as yet for patches applying outside $S (and not directly in $WORKDIR).
736xpatch() {
737
738 debug-print-function $FUNCNAME $* 1461 debug-print-function ${FUNCNAME} "${@}"
1462 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
739 1463
740 local list="" 1464 local flag=${1}
741 local list2="" 1465 local liuse=( ${IUSE} )
742 declare -i plevel
743 1466
744 # parse patch sources 1467 has "${flag}" "${liuse[@]#[+-]}"
745 for x in $*; do
746 debug-print "$FUNCNAME: parsing parameter $x"
747 if [ -f "$x" ]; then
748 list="$list $x"
749 elif [ -d "$x" ]; then
750 # handles patchdirs like epatch() for now: no recursion.
751 # patches are sorted by filename, so with an xy_foo naming scheme you'll get the right order.
752 # only patches with _$ARCH_ or _all_ in their filenames are applied.
753 for file in `ls -A $x`; do
754 debug-print "$FUNCNAME: parsing in subdir: file $file"
755 if [ -f "$x/$file" ] && [ "${file}" != "${file/_all_}" -o "${file}" != "${file/_$ARCH_}" ]; then
756 list2="$list2 $x/$file"
757 fi
758 done
759 list="`echo $list2 | sort` $list"
760 else
761 die "Couldn't find $x"
762 fi
763 done
764
765 debug-print "$FUNCNAME: final list of patches: $list"
766
767 for x in $list; do
768 debug-print "$FUNCNAME: processing $x"
769 # deal with compressed files. /usr/bin/file is in the system profile, or should be.
770 case "`/usr/bin/file -b $x`" in
771 *gzip*) patchfile="${T}/current.patch"; ungzip -c "$x" > "${patchfile}";;
772 *bzip2*) patchfile="${T}/current.patch"; bunzip2 -c "$x" > "${patchfile}";;
773 *text*) patchfile="$x";;
774 *) die "Could not determine filetype of patch $x";;
775 esac
776 debug-print "$FUNCNAME: patchfile=$patchfile"
777
778 # determine patchlevel. supports p0 and higher with either $S or $WORKDIR as base.
779 target="`/bin/grep -m 1 '^+++ ' $patchfile`"
780 debug-print "$FUNCNAME: raw target=$target"
781 # strip target down to the path/filename, remove leading +++
782 target="${target/+++ }"; target="${target%% *}"
783 # duplicate slashes are discarded by patch wrt the patchlevel. therefore we need
784 # to discard them as well to calculate the correct patchlevel.
785 target="${target//\/\//\/}"
786 debug-print "$FUNCNAME: stripped target=$target"
787
788 # look for target
789 for basedir in "$S" "$WORKDIR" "${PWD}"; do
790 debug-print "$FUNCNAME: looking in basedir=$basedir"
791 cd "$basedir"
792
793 # try stripping leading directories
794 target2="$target"
795 plevel=0
796 debug-print "$FUNCNAME: trying target2=$target2, plevel=$plevel"
797 while [ ! -f "$target2" ]; do
798 target2="${target2#*/}" # removes piece of target2 upto the first occurence of /
799 plevel=plevel+1
800 debug-print "$FUNCNAME: trying target2=$target2, plevel=$plevel"
801 [ "$target2" == "${target2/\/}" ] && break
802 done
803 test -f "$target2" && break
804
805 # try stripping filename - needed to support patches creating new files
806 target2="${target%/*}"
807 plevel=0
808 debug-print "$FUNCNAME: trying target2=$target2, plevel=$plevel"
809 while [ ! -d "$target2" ]; do
810 target2="${target2#*/}" # removes piece of target2 upto the first occurence of /
811 plevel=plevel+1
812 debug-print "$FUNCNAME: trying target2=$target2, plevel=$plevel"
813 [ "$target2" == "${target2/\/}" ] && break
814 done
815 test -d "$target2" && break
816
817 done
818
819 test -f "${basedir}/${target2}" || test -d "${basedir}/${target2}" || die "Could not determine patchlevel for $x"
820 debug-print "$FUNCNAME: determined plevel=$plevel"
821 # do the patching
822 ebegin "Applying patch ${x##*/}..."
823 /usr/bin/patch -p$plevel < "$patchfile" > /dev/null || die "Failed to apply patch $x"
824 eend $?
825
826 done
827
828} 1468}
829 1469
830# Unpack those pesky makeself generated files ... 1470# @FUNCTION: use_if_iuse
831# They're shell scripts with the binary package tagged onto 1471# @USAGE: <flag>
832# the end of the archive. Loki utilized the format as does 1472# @DESCRIPTION:
833# many other game companies. 1473# Return true if the given flag is in USE and IUSE.
834# 1474#
835# Usage: unpack_makeself [file to unpack] [offset] 1475# Note that this function should not be used in the global scope.
836# - If the file is not specified then unpack will utilize ${A}. 1476use_if_iuse() {
837# - If the offset is not specified then we will attempt to extract 1477 in_iuse $1 || return 1
838# the proper offset from the script itself. 1478 use $1
839unpack_makeself() { 1479}
840 local src=$1
841 local skip=$2
842 1480
843 [ -z "${src}" ] && src=${A} 1481# @FUNCTION: usex
844 [ -e ./${src} ] \ 1482# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
845 && src=${PWD}/${src} \ 1483# @DESCRIPTION:
846 || src=${DISTDIR}/${src} 1484# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
847 local shrtsrc=`basename ${src}` 1485# otherwise echo [false output][false suffix] (defaults to "no").
848 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1486usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
849 if [ -z "${skip}" ] ; then 1487
850 local ver="`grep -a '#.*Makeself' ${src} | awk '{print $NF}'`" 1488check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
851 local skip=0 1489
852 case ${ver} in
853 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
854 skip=`grep -a ^skip= ${src} | cut -d= -f2`
855 ;;
856 2.0|2.0.1)
857 skip=`grep -a ^$'\t'tail ${src} | awk '{print $2}' | cut -b2-`
858 ;;
859 2.1.1)
860 skip=`grep -a ^offset= ${src} | awk '{print $2}' | cut -b2-`
861 let skip="skip + 1"
862 ;;
863 *)
864 eerror "I'm sorry, but I was unable to support the Makeself file."
865 eerror "The version I detected was '${ver}'."
866 eerror "Please file a bug about the file ${shrtsrc} at"
867 eerror "http://bugs.gentoo.org/ so that support can be added."
868 die "makeself version '${ver}' not supported"
869 ;;
870 esac
871 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
872 fi 1490fi
873
874 # we do this because otherwise a failure in gzip will cause 0 bytes to be sent
875 # to tar which will make tar not extract anything and exit with 0
876 local out="`tail +${skip} ${src} | gzip -cd | tar -x --no-same-owner -v -f -`"
877 [ -z "${out}" ] && die "failure unpacking makeself ${shrtsrc} ('${ver}' +${skip})"
878}

Legend:
Removed from v.1.45  
changed lines
  Added in v.1.382

  ViewVC Help
Powered by ViewVC 1.1.20